
local func = {}
local chs = TheSim:GetLanguageCode() == "schinese"
local slotpos = {}
local GIFT_SLOTS = 4
local GOLD_STACKSIZE = 20 -- 默认20，兼容更改堆叠上限的mod
local MAX_PACK = GOLD_STACKSIZE * GIFT_SLOTS -- 默认80，兼容修改包裹格子数量的mod
local TRADE_ITEM = "goldnugget"

for y=2.5,-0.5,-1 do
	for x=0,2 do
		table.insert(slotpos, Vector3(75*x-75*2+75, 75*y-75*2+75,0))
	end
end

local function checkstack()
	-- 最大堆叠与包裹格子数测试
	local temp = SpawnPrefab("bundle_container")
	if temp then
		GIFT_SLOTS = temp.components.container and temp.components.container.numslots or 4
		temp:Remove()
	end
	local temp = SpawnPrefab(TRADE_ITEM)
	if temp then
		GOLD_STACKSIZE = temp.components.stackable and temp.components.stackable.maxsize or 20
		temp:Remove()
	end
	MAX_PACK = GOLD_STACKSIZE * GIFT_SLOTS or 80
	temp = nil
end

local function itemtest(inst, item, slot)
	return item.components.edible and item.components.edible.foodtype == "MEAT" or
		item.components.tradable and item.components.tradable.goldvalue > 0 or
		item.prefab == "bundle" and item:HasTag("killpaper")
end

local function ChangeAnim(inst)
	inst.AnimState:OverrideSymbol("bundle01", "pigkinggift", "pigkinggift"..inst.pigkinggifttype)
	inst.components.inventoryitem.atlasname = "images/inventoryimages/pigkinggift.xml"
	inst.components.inventoryitem:ChangeImageName("pigkinggift"..inst.pigkinggifttype.."_"..inst.pigkinggiftsize)
end

local function ChangeToGift(inst, data)
	inst:AddTag("killpaper")
	inst.name = chs and "礼物" or "Gift"
	-- 随机生成礼物样式
	local old = inst.components.unwrappable.onwrappedfn
	inst.components.unwrappable.onwrappedfn = function(inst, num, doer)
		old(inst, num, doer)
		inst.pigkinggifttype = math.random(1,2)
		if num > 3 then
			inst.pigkinggiftsize = 3
		elseif num > 1 then
			inst.pigkinggiftsize = 2
		else
			inst.pigkinggiftsize = 1
		end
		ChangeAnim(inst)
	end
	-- 拆包不返还打包纸
	inst.components.unwrappable.onunwrappedfn = function(inst, pos, doer)
		if inst.burnt then
			SpawnPrefab("ash").Transform:SetPosition(pos:Get())
		end
		if doer and doer.SoundEmitter then
			doer.SoundEmitter:PlaySound("dontstarve/common/together/packaged")
		end
		inst:Remove()
	end
	-- 拆包自动进包
	local old = inst.components.unwrappable.Unwrap
	inst.components.unwrappable.Unwrap = function(self, doer)
		if self.itemdata ~= nil and doer and doer.components.inventory then
			for i,v in ipairs(self.itemdata) do
				local item = SpawnPrefab(v.prefab)
				if item ~= nil and item:IsValid() then
					item:SetPersistData(v.data)
					doer.components.inventory:GiveItem(item, nil, Vector3(TheSim:GetScreenPos(self.inst.Transform:GetWorldPosition())))
				end
			end
			self.itemdata = nil
			if self.onunwrappedfn ~= nil then
				local pos = self.inst:GetPosition()
				self.onunwrappedfn(self.inst, pos, doer)
			end
		else
			old(self, doer)
		end
	end
	-- 读取礼物样式
	if data then
		inst.pigkinggifttype = data.pigkinggifttype
		inst.pigkinggiftsize = data.pigkinggiftsize
		ChangeAnim(inst)
	end
end

local function MakeGiftTable(fullslotnum, restnum)
	local t = {}
	if fullslotnum > 0 then
		for i=1, fullslotnum do
			table.insert(t, {prefab = TRADE_ITEM, count = GOLD_STACKSIZE})
		end
	end
	if fullslotnum < #slotpos then
		if restnum > 0 then
			table.insert(t, {prefab = TRADE_ITEM, count = restnum})
		end
	end
	return t
end

local function MakeGift(fullslotnum, restnum)
	local t = MakeGiftTable(fullslotnum, restnum)
	local items = {}
	for i=1,#t do
		local myitem = SpawnPrefab(t[i].prefab)
		if t[i].count > 1 then
			myitem.components.stackable:SetStackSize(t[i].count)
		end
		table.insert(items, myitem)
	end
	local gift = SpawnPrefab("bundle")
	ChangeToGift(gift)
	gift.components.unwrappable:WrapItems(items)
	for _,v in pairs(items) do
		v:Remove()
	end
	t,items = nil,nil
	return gift
end

local function buttonfn(inst, doer)
	if GetClock():IsNight() then
		if doer and doer.components.talker then
			doer.components.talker:Say(chs and "现在是睡觉时间！" or "It's sleeping time!")
		end
		return
	end
	local item
	local num = 0
	for i=1,#slotpos do
		item = inst.components.container:GetItemInSlot(i)
		local stack = 1
		if item then
			local gold = 0
			if item.components.edible and item.components.edible.foodtype == "MEAT" then
				gold = 1
			end
			if item.components.tradable and item.components.tradable.goldvalue > 0 then
				gold = item.components.tradable.goldvalue
			end
			if gold > 0 then
				if item.components.stackable then
					stack = item.components.stackable:StackSize()
				end
				num = num + stack * gold
				inst.components.container:ConsumeByName(item.prefab, stack)
			end
			gold = nil
		end
		stack = nil
	end
	item = nil
	local fullpacknum = math.floor(num / MAX_PACK) -- 满包数
	local restpackitemnum = num % MAX_PACK -- 剩余非满包内容物总数
	local restpackfullslotnum = math.floor(restpackitemnum / GOLD_STACKSIZE) -- 剩余非满包满堆叠格子数
	local restpackrestnum = restpackitemnum % GOLD_STACKSIZE -- 剩余非满包剩余物品数
	--[[print("\n"..
		"总金子数："..num.."\n"..
		"包裹格子："..GIFT_SLOTS.."\n"..
		"最大堆叠："..GOLD_STACKSIZE.."\n"..
		"满包数量："..fullpacknum.."\n"..
		"剩余总数："..restpackitemnum.."\n"..
		"剩余满格："..restpackfullslotnum.."\n"..
		"剩余剩余："..restpackrestnum)]]
	num = nil
	-- 生成满包
	if fullpacknum > 0 then
		for i=1,fullpacknum do
			item = MakeGift(GIFT_SLOTS, 0)
			if item then
				inst.components.container:GiveItem(item)
			end
		end
	end
	-- 生成剩余包
	if restpackitemnum > 0 then
		item = MakeGift(restpackfullslotnum, restpackrestnum)
		if item then
			inst.components.container:GiveItem(item)
		end
	end
	if item and doer and doer.SoundEmitter then
		doer.SoundEmitter:PlaySound("dontstarve/wilson/equip_item_gold")
	end
	fullpacknum, restpackitemnum, restpackfullslotnum, restpackrestnum = nil,nil,nil,nil
end

function func.pigking(inst)
	MakeObstaclePhysics(inst,1.4,.5)
	inst:AddComponent("container")
	inst.components.container.itemtestfn = itemtest
	inst.components.container:SetNumSlots(#slotpos)
	inst.components.container.widgetslotpos = slotpos
	inst.components.container.widgetanimbank = "ui_chester_shadow_3x4"
	inst.components.container.widgetanimbuild = "ui_chester_shadow_3x4"
	inst.components.container.widgetpos = Vector3(0,-125,0)
	inst.components.container.side_align_tip = 0
	inst.components.container.type = "iceamei_pigking"
	inst.components.container.widgetbuttoninfo = {
		text = chs and "交易" or "TRADE",
		position = Vector3(0,-175,0),
		fn = buttonfn,
	}
	checkstack()
end

function func.bundle(inst)
	local old = inst.OnSave
	inst.OnSave = function(inst, data)
		if old then
			old(inst, data)
		end
		if inst:HasTag("killpaper") then
			data.killpaper = true
		end
		data.pigkinggifttype = inst.pigkinggifttype
		data.pigkinggiftsize = inst.pigkinggiftsize
	end
	local old = inst.OnLoad
	inst.OnLoad = function(inst, data)
		if old then
			old(inst, data)
		end
		if data.killpaper and data.pigkinggifttype and data.pigkinggiftsize then
			ChangeToGift(inst, data)
		end
	end
end

return func
